"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
function Avatar(props) {
    var bem = hooks_1.useBem('AvatarView');
    var customSize = typeof props.size === 'number'
        ? {
            width: props.size,
            height: props.size,
            lineHeight: props.size + "px",
            fontSize: props.size / 2
        }
        : {};
    var renderImage = function () { return ((props.isError && (react_1["default"].createElement("span", null, props.formattedTitle))) || (react_1["default"].createElement("img", { alt: props.alt, src: props.src, title: props.title, srcSet: props.srcSet, onError: props.onError }))); };
    return (react_1["default"].createElement("div", { className: bem(bem.block({
            size: props.size,
            shape: props.shape,
            'has-image': !!props.src && !props.isError,
            'has-status': props.status
        }), props.className) },
        react_1["default"].createElement("span", { className: bem.element('body'), style: __assign(__assign({}, props.style), customSize) },
            (props.src && renderImage()) || (react_1["default"].createElement("span", null, props.formattedTitle)),
            props.children)));
}
exports["default"] = Avatar;
