"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var react_1 = require("react");
var hooks_1 = require("@steroidsjs/core/hooks");
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/icon/Icon"));
var upperFirst_1 = __importDefault(require("lodash-es/upperFirst"));
function CaptionElement(props) {
    var bem = hooks_1.useBem('CaptionElement');
    var localeUtils = props.localeUtils, locale = props.locale, fromYear = props.fromYear, toYear = props.toYear, date = props.date, isCaptionPanelVisible = props.isCaptionPanelVisible, toggleCaptionPanel = props.toggleCaptionPanel;
    var currentMonth = date.getMonth();
    var currentYear = date.getFullYear();
    var handleYearChange = function (newYear) {
        if (newYear !== currentYear) {
            props.onChange(new Date(newYear, currentMonth));
        }
    };
    var handleMonthChange = function (newMonth) {
        if (newMonth !== currentMonth) {
            props.onChange(new Date(currentYear, newMonth));
        }
    };
    var months = react_1.useMemo(function () { return (localeUtils.getMonths(locale).map(function (item, index) { return ({
        id: index,
        label: upperFirst_1["default"](item)
    }); })); }, [localeUtils, locale]);
    var years = react_1.useMemo(function () {
        var result = [];
        for (var i = fromYear.getFullYear(); i <= toYear.getFullYear(); i += 1) {
            result.push(i);
        }
        return result;
    }, [fromYear, toYear]);
    return (React.createElement("div", { className: bem(bem.block()) },
        React.createElement("div", { className: bem.element('container') },
            React.createElement(Icon_1["default"], { className: bem.element('button'), onClick: function (e) {
                    e.preventDefault();
                    handleYearChange(currentYear - 1);
                }, name: 'angle-double-left' }),
            React.createElement(Icon_1["default"], { className: bem.element('button', 'one-arrow'), onClick: function (e) {
                    e.preventDefault();
                    handleMonthChange(currentMonth - 1);
                }, name: 'angle-left' }),
            React.createElement("div", { className: bem.element('content-container'), onKeyPress: function (e) {
                    e.preventDefault();
                    toggleCaptionPanel();
                }, onClick: function (e) {
                    e.preventDefault();
                    toggleCaptionPanel();
                }, role: 'button', tabIndex: 0 },
                React.createElement("span", { className: bem.element('selected-month') }, months.find(function (month) { return month.id === currentMonth; }).label),
                React.createElement("span", { className: bem.element('selected-year') }, years.find(function (year) { return year === currentYear; }))),
            React.createElement(Icon_1["default"], { className: bem.element('button', 'one-arrow'), onClick: function (e) {
                    e.preventDefault();
                    handleMonthChange(currentMonth + 1);
                }, name: 'angle-right' }),
            React.createElement(Icon_1["default"], { className: bem.element('button'), onClick: function (e) {
                    e.preventDefault();
                    handleYearChange(currentYear + 1);
                }, name: 'angle-double-right' })),
        isCaptionPanelVisible && (React.createElement("div", { className: bem.element('panel', { 'full-height': !props.showCalendarFooter }) },
            React.createElement("div", { className: bem.element('panel-header', 'months') }, __('Месяц')),
            React.createElement("div", { className: bem.element('panel-header', 'years') }, __('Год')),
            React.createElement("div", { className: bem.element('panel-column-months', 'first') },
                React.createElement("div", { className: bem.element('content-column') }, months.slice(0, 6).map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('panel-cell', {
                        selected: value.id === currentMonth
                    }), onKeyPress: function (e) {
                        e.preventDefault();
                        handleMonthChange(value.id);
                    }, onClick: function (e) {
                        e.preventDefault();
                        handleMonthChange(value.id);
                    }, role: 'button', tabIndex: 0 },
                    React.createElement("div", { className: bem.element('cell-value') }, value.label))); }))),
            React.createElement("div", { className: bem.element('panel-column-months', 'second') }, months.slice(6, 12).map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('panel-cell', {
                    selected: value.id === currentMonth
                }), onKeyPress: function (e) {
                    e.preventDefault();
                    handleMonthChange(value.id);
                }, onClick: function (e) {
                    e.preventDefault();
                    handleMonthChange(value.id);
                }, role: 'button', tabIndex: 0 },
                React.createElement("div", { className: bem.element('cell-value') }, value.label))); })),
            React.createElement("div", { className: bem.element('panel-column-years') }, years.map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('panel-cell', {
                    selected: value === currentYear
                }), onKeyPress: function (e) {
                    e.preventDefault();
                    handleYearChange(value);
                }, onClick: function (e) {
                    e.preventDefault();
                    handleYearChange(value);
                }, role: 'button', tabIndex: 0 },
                React.createElement("div", { className: bem.element('cell-value') }, value))); }))))));
}
exports["default"] = CaptionElement;
