"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
function DropDownFieldView(props) {
    /* TODO Move to core component
    static defaultProps = {
        searchAutoFocus: true,
    };

    componentDidUpdate(prevProps) {
        // Auto focus on search
        if (props.searchAutoFocus && props.autoComplete && !prevProps.isOpened && props.isOpened) {
            const element: any = findDOMNode(this);
            const input = element.querySelector('.' + props.bem.element('search-input'));
            if (input) {
                input.focus();
            }
        }
    }*/
    var bem = hooks_1.useBem('DropDownFieldView');
    return (React.createElement("div", { ref: props.forwardedRef, className: bem(bem.block({ size: props.size }), props.className), style: props.style },
        React.createElement("div", { className: bem.element('selected-items', {
                reset: props.showReset,
                'no-border': props.noBorder,
                'is-invalid': !!props.errors,
                disabled: props.disabled
            }), onClick: props.onOpen, onKeyPress: props.onOpen, tabIndex: 0, role: 'button' }, props.multiple
            ? props.selectedIds
                .map(function (id) { return props.items.find(function (item) { return item[props.primaryKey] === id; }); })
                .filter(Boolean)
                .map(function (item) { return (React.createElement("span", { key: String(item.id), className: bem.element('selected-item-multiple') },
                item.label,
                React.createElement("span", { className: bem.element('selected-item-multiple-remove'), onClick: function (e) {
                        e.preventDefault();
                        e.stopPropagation();
                        props.onItemRemove(item[props.primaryKey]);
                    }, onKeyPress: function (e) {
                        e.preventDefault();
                        e.stopPropagation();
                        props.onItemRemove(item[props.primaryKey]);
                    }, tabIndex: 0, role: 'button' },
                    React.createElement("svg", { viewBox: "64 64 896 896", className: "", width: "1em", height: "1em" },
                        React.createElement("path", { d: "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3\n                                         5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4\n                                         512 196.9 824.9A7.95 7.95 0 00203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3\n                                          3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" }))))); })
            : props.selectedIds
                .map(function (id) { return props.items.find(function (item) { return item[props.primaryKey] === id; }); })
                .filter(Boolean)
                .map(function (item) { return (React.createElement("span", { key: item.id, className: bem.element('selected-item') }, item.label)); })),
        props.showReset && props.selectedIds.length > 0 && (React.createElement("button", { className: bem.element('reset'), onClick: props.onReset, "aria-label": __('Сбросить') })),
        props.isOpened && (React.createElement("div", { className: bem.element('drop-down') },
            props.isAutoComplete && (React.createElement("div", { className: bem.element('search') },
                React.createElement("input", __assign({}, props.searchInputProps, { onChange: function (e) { return props.searchInputProps.onChange(e.target.value); }, className: bem('form-control', 'form-control-' + props.size, bem.element('search-input'), props.searchInputProps.className) })))),
            React.createElement("div", { className: bem.element('drop-down-list') }, props.items.map(function (item) { return (React.createElement("button", { key: String(item[props.primaryKey]), type: 'button', className: bem.element('drop-down-item', {
                    hover: props.hoveredId === item[props.primaryKey],
                    select: props.selectedIds.includes(item[props.primaryKey])
                }), onClick: function (e) {
                    e.preventDefault();
                    props.onItemSelect(item[props.primaryKey]);
                }, onFocus: function () { return props.onItemHover(item[props.primaryKey]); }, onMouseOver: function () { return props.onItemHover(item[props.primaryKey]); } }, item.label)); }))))));
}
exports["default"] = DropDownFieldView;
