"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
exports.__esModule = true;
var React = __importStar(require("react"));
var react_1 = require("react");
var hooks_1 = require("@steroidsjs/core/hooks");
function NumberFieldView(props) {
    // Input ref
    var inputRef = react_1.useRef(null);
    // Value state
    var _a = react_1.useState(null), value = _a[0], setValue = _a[1];
    var onStepUp = function () {
        inputRef.current.stepUp();
        setValue(inputRef.current.value);
    };
    var onStepDown = function () {
        inputRef.current.stepDown();
        setValue(inputRef.current.value);
    };
    var bem = hooks_1.useBem('NumberFieldView');
    return (React.createElement("div", { className: bem(bem.block({
            disabled: props.inputProps.disabled
        }), 'form-control', 'form-control-' + props.size, !!props.errors && 'is-invalid', props.className) },
        React.createElement("input", __assign({ ref: inputRef, className: bem(bem.element('input', {
                size: props.size
            }), !!props.errors && 'is-invalid') }, props.inputProps)),
        !props.disabled && !props.errors && (React.createElement("div", { className: bem.element('arrows-container') },
            React.createElement("button", { className: bem.element('arrow', {
                    disabled: props.inputProps.max && value >= props.inputProps.max
                }), onClick: onStepUp },
                React.createElement("svg", { viewBox: '64 64 896 896', width: '1em', height: '1em' },
                    React.createElement("path", { d: 'M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5\n                                    0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39\n                                    17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z' }))),
            React.createElement("button", { className: bem.element('arrow', {
                    disabled: props.inputProps.min && value <= props.inputProps.min
                }), onClick: onStepDown },
                React.createElement("svg", { viewBox: '64 64 896 896', width: '1em', height: '1em' },
                    React.createElement("path", { d: 'M890.5 755.3L537.9 269.2c-12.8-17.6-39-17.6-51.7 0L133.5 755.3A8 8 0 00140\n                                    768h75c5.1 0 9.9-2.5 12.9-6.6L512 369.8l284.1\n                                    391.6c3 4.1 7.8 6.6 12.9 6.6h75c6.5 0 10.3-7.4 6.5-12.7z' })))))));
}
exports["default"] = NumberFieldView;
