"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var padStart_1 = __importDefault(require("lodash-es/padStart"));
var getHours = function () {
    var result = [];
    for (var i = 0; i < 24; i += 1) {
        var hour = padStart_1["default"](i, 2, '0');
        result.push(hour);
    }
    return result;
};
var getMinutes = function () {
    var result = [];
    for (var i = 0; i < 60; i += 1) {
        var minute = padStart_1["default"](i, 2, '0');
        result.push(minute);
    }
    return result;
};
function TimePanelView(props) {
    var bem = hooks_1.useBem('TimePanelView');
    var _a = props.value ? props.value.split(':') : ['00', '00'], hours = _a[0], minutes = _a[1];
    return (React.createElement("div", { className: bem(bem.block(), props.className) },
        props.showHeader && (React.createElement("div", { className: bem.element('header') }, props.value && (hours + ":" + minutes))),
        React.createElement("div", { className: bem.element('body') },
            React.createElement("div", { className: bem.element('column') }, getHours().map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('cell', {
                    selected: value === hours
                }), onKeyPress: function (e) {
                    e.preventDefault();
                    props.onSelect(value + ':' + minutes);
                }, onClick: function (e) {
                    e.preventDefault();
                    props.onSelect(value + ':' + minutes);
                }, role: 'button', tabIndex: 0 },
                React.createElement("div", { className: bem.element('cell-value') }, value))); })),
            React.createElement("div", { className: bem.element('column') }, getMinutes().map(function (value, index) { return (React.createElement("div", { key: index, className: bem.element('cell', {
                    selected: value === minutes
                }), onKeyPress: function (e) {
                    e.preventDefault();
                    props.onSelect(hours + ':' + value);
                }, onClick: function (e) {
                    e.preventDefault();
                    props.onSelect(hours + ':' + value);
                }, role: 'button', tabIndex: 0 },
                React.createElement("div", { className: bem.element('cell-value') }, value))); }))),
        React.createElement("div", { className: bem.element('footer', { 'to-end': !props.showNow }) },
            props.showNow && (React.createElement("button", { className: bem.element('button', 'now'), onClick: function (e) {
                    e.preventDefault();
                    props.onNow();
                } }, __('Текущее'))),
            React.createElement("button", { className: bem.element('button', 'ok'), onClick: function (e) {
                    e.preventDefault();
                    props.onClose();
                } }, __('Ок')))));
}
TimePanelView.defaultProps = {
    showHeader: false,
    showNow: true
};
exports["default"] = TimePanelView;
