"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.getFormId = void 0;
var React = __importStar(require("react"));
var get_1 = __importDefault(require("lodash-es/get"));
var keyBy_1 = __importDefault(require("lodash-es/keyBy"));
var isString_1 = __importDefault(require("lodash-es/isString"));
var Button_1 = __importDefault(require("@steroidsjs/core/ui/form/Button"));
var Field_1 = __importDefault(require("@steroidsjs/core/ui/form/Field"));
var hooks_1 = require("@steroidsjs/core/hooks");
var react_1 = require("react");
var getFormId = function (props) { return get_1["default"](props, 'searchForm.formId', props.listId); };
exports.getFormId = getFormId;
function GridView(props) {
    var _a;
    var bem = hooks_1.useBem('GridView');
    var renderInsideSearchForm = react_1.useCallback(function () {
        if (!props.searchForm || !props.searchForm.fields || props.searchForm.layout !== 'table') {
            return null;
        }
        var fields = keyBy_1["default"](props.searchForm.fields.map(function (column) { return isString_1["default"](column) ? { attribute: column } : column; }), 'attribute');
        return (React.createElement("tr", null, props.columns.map(function (column, columnIndex) { return (React.createElement("td", { key: columnIndex, className: column.headerClassName }, column.attribute && fields[column.attribute] && (React.createElement(Field_1["default"], __assign({ layout: 'inline' }, fields[column.attribute]))))); })));
    }, [props.searchForm, props.columns]);
    var renderSortButton = react_1.useCallback(function (attribute, direction) {
        var _a;
        var sortKey = (direction === 'desc' ? '-' : '') + attribute;
        var isActive = [].concat(((_a = props.list) === null || _a === void 0 ? void 0 : _a.sort) || []).includes(sortKey);
        return (React.createElement(Button_1["default"], { icon: direction === 'asc' ? 'long-arrow-alt-up' : 'long-arrow-alt-down', className: bem.element('sort-button', {
                'is-active': isActive
            }), link: true, onClick: function (e) {
                e.preventDefault();
                props.onSort(!isActive ? sortKey : null);
            } }));
    }, [props.onSort, (_a = props.list) === null || _a === void 0 ? void 0 : _a.sort]);
    var emptyContent = react_1.useMemo(function () { return props.renderEmpty(); }, [props.renderEmpty]);
    return props.renderList(React.createElement("div", { className: bem(bem.block({ loading: props.isLoading }), props.className) },
        props.renderSearchForm(),
        props.renderPaginationSize(),
        React.createElement("table", { className: 'table table-striped' },
            React.createElement("thead", null,
                React.createElement("tr", null, props.columns.map(function (column, columnIndex) { return (React.createElement("th", { key: columnIndex, className: column.headerClassName },
                    column.label,
                    column.sortable && column.attribute && (React.createElement("span", null,
                        column.label && React.createElement("span", null, "\u00A0"),
                        renderSortButton(column.attribute, 'asc'),
                        renderSortButton(column.attribute, 'desc'))))); })),
                renderInsideSearchForm()),
            React.createElement("tbody", null,
                props.items && props.items.map(function (item, rowIndex) { return (React.createElement("tr", { key: item[props.primaryKey] || rowIndex }, props.columns.map(function (column, columnIndex) { return (React.createElement("td", { key: columnIndex, className: column.className, "data-label": isString_1["default"](column.label) ? column.label : null }, props.renderValue(item, column))); }))); }),
                emptyContent && (React.createElement("tr", null,
                    React.createElement("td", { colSpan: props.columns.length }, emptyContent))))),
        props.renderPagination()));
}
exports["default"] = GridView;
